
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>PHP Wrapper在SAE上的应用方法_php技巧 / iVAN</title>

    <meta name="description" content="PHP Wrapper在SAE上的应用方法_php技巧 本文讲述了PHP Wrapper在SAE上的应用方法.分享给大家供大家参考,具体如下: 一.PHP Wrapper是什么 自PHP 4.3开始,PHP开始允许用户通过stream_wrapper_register()自定义URL风格的协议.用户使用fopen(), copy()等文件系统函数对封装协议进行操作时,PHP会调用注册协议时所提供的类中相应的函数. PHP手册中给了一个例子,它将VariableStream类注册为var://协议,通过这个协议,用户可以使用文件系统函数直接读写全局变量">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">PHP Wrapper在SAE上的应用方法_php技巧</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>本文讲述了PHP Wrapper在SAE上的应用方法。分享给大家供大家参考，具体如下：</p>
<p><strong>一、PHP Wrapper是什么</strong></p>
<p>自PHP 4.3开始，PHP开始允许用户通过stream_wrapper_register()自定义URL风格的协议。用户使用fopen(), copy()等文件系统函数对封装协议进行操作时，PHP会调用注册协议时所提供的类中相应的函数。<br />
PHP手册中给了一个例子，它将VariableStream类注册为var://协议，通过这个协议，用户可以使用文件系统函数直接读写全局变量。例如，用户可以通过 “var://foo” 读写 $GLOBALS['foo'] 。</p>
<p><strong>二、SAE为什么需要PHP Wrapper</strong></p>
<p>出于性能和安全方面的考虑，SAE平台上禁用了本地文件读写和对外的数据抓取。相应的，我们提供了对应的服务来做同样的事情。</p>
<p>由于新服务的接口和PHP本身的接口不太一样，专门为我们平台开发的程序当然不会存在问题，但是大量已有的程序和开源项目，就面临着繁杂的迁移工作。而使用PHP Wrapper对我们的服务的接口进行封装之后，用户就可以更方便地将程序迁移到SAE平台。</p>
<p><strong>三、如何写PHP Wrapper</strong></p>
<p>要通过PHP Wrapper封装一个协议，首先，我们需要写一个 streamWrapper 类，类名可自定义，类的格式为：</p>
<pre>
streamWrapper {
public resource $context ;
__construct ( void )
public bool dir_closedir ( void )
public bool dir_opendir ( string $path , int $options )
public string dir_readdir ( void )
public bool dir_rewinddir ( void )
public bool mkdir ( string $path , int $mode , int $options )
public bool rename ( string $path_from , string $path_to )
public bool rmdir ( string $path , int $options )
public resource stream_cast ( int $cast_as )
public void stream_close ( void )
public bool stream_eof ( void )
public bool stream_flush ( void )
public bool stream_lock ( mode $operation )
public bool stream_open ( string $path , string $mode , int $options , string &amp;$opened_path )
public string stream_read ( int $count )
public bool stream_seek ( int $offset , int $whence = SEEK_SET )
public bool stream_set_option ( int $option , int $arg1 , int $arg2 )
public array stream_stat ( void )
public int stream_tell ( void )
public int stream_write ( string $data )
public bool unlink ( string $path )
public array url_stat ( string $path , int $flags )
}
</pre>
<p><strong>类中各方法说明：</strong></p>
<p>streamWrapper::__construct — 构造函数，仅在stream_open前被调用<br />
streamWrapper::dir_closedir — 关闭目录句柄，响应closedir()函数<br />
streamWrapper::dir_opendir — 打开目录句柄，响应opendir()函数<br />
streamWrapper::dir_readdir — 从目录句柄读取条目，响应readdir()函数<br />
streamWrapper::dir_rewinddir — 倒回目录句柄，响应rewinddir()函数<br />
streamWrapper::mkdir — 创建目录，响应mkdir()函数<br />
streamWrapper::rename — 目录或文件重命名，响应rename()函数<br />
streamWrapper::rmdir — 删除目录，响应rmdir()函数<br />
streamWrapper::stream_cast — 检索基础资源，响应stream_select()函数<br />
streamWrapper::stream_close — 关闭资源，响应fclose()函数<br />
streamWrapper::stream_eof — 检查文件指针是否已经在文件末尾，响应feof()函数<br />
streamWrapper::stream_flush — 清除输出缓存，响应fflush()函数<br />
streamWrapper::stream_lock — 咨询文件锁定，响应flock()函数<br />
streamWrapper::stream_open — 打开文件或URL为流，响应fopen()函数<br />
streamWrapper::stream_read — 从流中读取内容，响应fread(), fgets()函数<br />
streamWrapper::stream_seek — 在流中定位指针，响应fseek()函数<br />
streamWrapper::stream_set_option — 改变流设置<br />
streamWrapper::stream_stat — 检索文件资源的信息，响应fstat()函数<br />
streamWrapper::stream_tell — 检索流中指针的位置，响应ftell()函数<br />
streamWrapper::stream_write — 向流中写入内容，响应fwrite(), fputs()函数<br />
streamWrapper::unlink — 删除文件，响应unlink()函数<br />
streamWrapper::url_stat — 检索文件的信息，响应所有stat()相关的函数，例如file_exists(), is_dir(), is_file(), filesize(), fileinode()等等</p>
<p>详细说明请参考PHP手册：http://cn2.php.net/manual/en/class.streamwrapper.php</p>
<p>写好streamWrapper类之后，使用 stream_wrapper_register () 将这个类注册到Wrapper中，就可以开始使用了。函数使用方法为：</p>
<p>bool stream_wrapper_register ( string $protocol , string $classname [, int $flags = 0 ] )</p>
<p>例如：</p>
<pre>
stream_wrapper_register("saemc", "SaeMemcacheWrapper");
</pre>
<p>由于SAE平台不支持对本地文件的写操作，因此Smarty之类的一些需要在本地写文件的开源项目就没办法直接在SAE平台上使用，而有了saemc Wrapper，用户就可以将Smarty编译的模板保存在MC中，很方便的将Smarty迁移到SAE平台上来。</p>
<p>在附件中我们为大家提供了SAE上Memcache Wrapper的实现代码，大家可以下载此附件进行测试。</p>
<p>在测试之前，需要先在本地启动一个端口为22222的Memcached服务：</p>
<pre>
memcached -m 10 -p 22222 -u nobody -l 127.0.0.1
</pre>
<p>然后使用下面代码就可以测试了：</p>
<pre>
//包含附件代码，注册saemc Wrapper
include_once('wrapper.php');
//测试 saemc Wrapper
$fp = fopen( "saemc://test.txt", "w+" ) or die("fopen faild!");
fwrite( $fp, "line1\n" ) or die("fwrite line1 faild!");
fwrite( $fp, "line2\n" ) or die("fwrite line2 faild!");
fwrite( $fp, "line3\n" ) or die("fwrite line3 faild!");
var_dump(ftell($fp));
fseek( $fp, 0 );
while ( !feof( $fp ) ) {
    $c = fgets( $fp ) or die("fgets faild!");
      var_dump($c);
}
fclose( $fp );
var_dump(file_get_contents("saemc://test.txt"));
var_dump(file_put_contents("saemc://path/test.txt", "hello world!\n"));
var_dump(file_put_contents("saemc://path/test.txt", "hello world!\n", FILE_APPEND));
var_dump(file_get_contents("saemc://path/test.txt"));
var_dump(copy("saemc://path/test.txt", "saemc://path/test_new.txt"));
var_dump(file_get_contents("saemc://path/test_new.txt"));
var_dump(unlink("saemc://path/test.txt"));
var_dump(file_get_contents("saemc://path/test.txt"));
var_dump(rename("saemc://path/test_new.txt", "saemc://path/test.txt"));
var_dump(file_get_contents("saemc://path/test.txt"));
echo "====test include====\n";
include_once("saemc://path/test.txt");
</pre>
<p>测试页面的输出结果：</p>
<pre>
int(18)
string(6) "line1
"
string(6) "line2
"
string(6) "line3
"
string(18) "line1
line2
line3
"
int(13)
int(13)
string(26) "hello world!
hello world!
"
bool(true)
string(26) "hello world!
hello world!
"
bool(true)
bool(false)
bool(true)
string(26) "hello world!
hello world!
"
====test include====
hello world!
hello world!
</pre>
<p>我们提供的 Memcache Wrapper并没有实现目录操作的一些方法和Memcache的Timeout，大家可以参考PHP手册，尝试实现目录操作，或者通过context使这个Wrapper支持Memcache的Timeout。</p>
<p>另外，大家可以到下面这个地址查看SAE Stdlib中sae_include的源码，在其中还有我们为Storage服务封装的saestor Wrapper和为Fetchurl服务重新封装的http Wrapper的实现：</p>
<p>http://stdlib.sinaapp.com/?f=sae_include.function.php</p>
<p><strong>四、写Wrapper时的一些注意事项</strong></p>
<p><strong>1. 构造函数</strong></p>
<p>streamWrapper 类很特别，它的构造函数并不是每次都调用的。只有在你的操作触发了stream_open相关的操作时才会调用，比如你用file_get_contents()了。而当你的操作触发和stream无关的函数时，比如file_exists会触发url_stat方法，这个时候构造函数是不会被调用的。</p>
<p><strong>2. 读实现</strong></p>
<p>Wrapper里边有Position和Seek等概念，但是很多服务其实是一次性就读取全部数据的，这个可以在stream_open的时候一次性读回，放到一个属性中，以后seek和tell的时候直接操作属性里边存放的数据就可以了。</p>
<p><strong>3. 追加写实现</strong></p>
<p>有很多服务是一次性写入所有数据，不支持追加写的功能（比如Memcache），这就需要我们自己在Wrapper中来实现追加写。可以将整个value一次性读取出来，将需要追加写的数据追加在读取出来的内容后面之后，再一次性写回。</p>
<p>但是这种追加写的实现方式性能会比较差，尤其是内容体积较大之后，一次性读取所有内容会非常消耗资源，因此在某些服务中我们不得不舍弃对追加写的支持。</p>
<p><strong>4. url_stat的实现</strong></p>
<p>在streamWrapper类的实现中，url_stat的实现是个难点。必须正确的实现url_stat才能使is_writable和is_readable等查询文件元信息的函数正常工作。</p>
<p>而我们需要为我们的虚设备伪造这些值。以mc为例，我们给大家一些参考数据：</p>
<p><strong>url_stat应该返回一个数组，分13个项，内容如下：</strong></p>
<p>dev 设备号 － 写0即可；<br />
ino inode号 － 写0即可；<br />
mode 文件mode － 这个是文件的权限控制符号，稍后详细说明；<br />
nlink link － 写0即可；<br />
uid uid － Linux上用posix_get_uid可以取到，windows上为0；<br />
gid gid － Linux上用posix_get_gid可以取到，windows上为0；<br />
rdev 设备类型 － 当为inode设备时有值；<br />
size － 文件大小；<br />
atime － 最后读时间 格式为unix时间戳；<br />
mtime － 最后写时间；<br />
ctime － 创建时间；<br />
blksize － blocksize of filesystem IO 写零即可；<br />
blocks － number of 512-byte blocks allocated 写零即可；</p>
<p>其中mode的值必须写对：</p>
<p>如果是文件,其值为：</p>
<p>0100000 + 文件权限，如 0100000 + 0777。</p>
<p>如果是目录,其值为：</p>
<p>040000 + 目录权限，如 0400000 + 0777。</p>
<p><strong>5. 关于stat的缓存</strong></p>
<p>PHP会在同一个页面的执行过程中对文件的元信息进行缓存。<br />
根据PHP文档对 clearstatcache() 这个方法的说明得知：在使用 stat(), lstat(), file_exists(), is_writable(), is_readable(), is_executable(), is_file(), is_dir(), is_link(), filectime(), fileatime(), filemtime(), fileinode(), filegroup(), fileowner(), filesize(), filetype(), 或 fileperms() 方法查询文件信息时，PHP会将文件的stat的缓存以提高性能。 clearstatcache()方法可以用来清除这个缓存，当unlink()会自动清除stat缓存。</p>
<p>而实际上，PHP只有在对本地文件进行unlink, rename和rmdir操作时会清除stat缓存，而在通过其他的wrapper进行unlink, rename和rmdir操作时，并不会清除stat缓存。因此在写wrapper时我们要自己在unlink等方法中通过clearstatcache()来清除stat缓存。</p>
<p>点击此处下载附件。</p>
<p>更多关于PHP相关内容感兴趣的读者可查看本站专题：《php curl用法总结》、《php socket用法总结》、《PHP网络编程技巧总结》、《PHP基本语法入门教程》、《php操作office文档技巧总结(包括word,excel,access,ppt)》、《php日期与时间用法总结》、《php面向对象程序设计入门教程》、《php字符串(string)用法总结》、《php+mysql数据库操作入门教程》及《php常见数据库操作技巧汇总》</p>
<p>希望本文所述对大家PHP程序设计有所帮助。</p>
<p>以上是小编为您精心准备的的内容，在的博客、问答、公众号、人物、课程等栏目也有的相关内容，欢迎继续使用右上角搜索按钮进行搜索php<br />
                    ，                sae<br />
                    ，                应用方法<br />
                                    Wrapper<br />
                                    php wrapper、php wrapper zip、sae应用仓库、新浪sae怎么关闭应用、sae git 部署应用，以便于您获取更多的相关知识。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-16 07:17:05</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/php/" title="php">php</a>, <a href="https://www.iamivan.net/tag/%e5%ba%94%e7%94%a8%e6%96%b9%e6%b3%95/" title="应用方法">应用方法</a>, <a href="https://www.iamivan.net/tag/sae/" title="sae">sae</a>, <a href="https://www.iamivan.net/tag/wrapper/" title="Wrapper">Wrapper</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>PHP Wrapper在SAE上的应用方法_php技巧的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ze7BVjM.html" rel="bookmark">PHP实现多文件上传的方法&lowbar;php技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了PHP实现多文件上传的方法.分享给大家供大家参考.具体实现方法如下: &lt;?php define('ROOT','D:/Program Files/www/test/'); class Files_Tool{ protected static $allowExt=array('.jpg','.jpeg','.png','.gif','.bmp','.svg','.chm','.pdf','.zip','.rar','.tar','.gz','.bzip2','.ppt','.doc'			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pnYle0M.html" rel="bookmark">PHP判断是否连接上网络的方法&lowbar;php技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了PHP判断是否连接上网络的方法.分享给大家供大家参考.具体实现方法如下: 首先写个函数 function varify_url($url){ $check = @fopen($url,&quot;r&quot;); if($check){ $status = true; }else{ $status = false; } return $status; } 接着在需要的地方直接调用即可 $url = &quot;http://www.baidu.com&quot;; if(varify_ur			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MrXPxOz.html" rel="bookmark">php实现curl模拟ftp上传的方法&lowbar;php技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了php实现curl模拟ftp上传的方法.分享给大家供大家参考.具体如下: &lt;?php function upload($dir,$src,$dest) { $ch = curl_init(); $fp = fopen($src, 'r'); curl_setopt($ch, CURLOPT_URL, 'ftp://user:pwd@host/interpretation/'.$dir .'/'. $dest); curl_setopt($ch, CURLOPT_UPLOAD, 1)			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MgEJy5z.html" rel="bookmark">php实现在服务器上创建目录的方法&lowbar;php技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了php实现在服务器上创建目录的方法.分享给大家供大家参考.具体分析如下: 下面的代码先判断目录是否存在,然后通过mkdir()函数在服务器上创建了一个目录 &lt;?php if (file_exists(&quot;/temp/test&quot;)) { print(&quot;Test Directory already exists.\n&quot;); } else { mkdir(&quot;/temp/test&quot;); print(&quot;Test Director			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zDK2nXp.html" rel="bookmark">php使用ereg验证文件上传的方法&lowbar;php技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了php使用ereg验证文件上传的方法.分享给大家供大家参考.具体分析如下: ereg格式如下: 复制代码 代码如下: ereg(正规表达式,字符串,[匹配部分数组名]); 这里利用了ereg来验证用户上传的文件类型与文件名是否是符合文件命名规则,实例代码如下: 复制代码 代码如下: if( !is_uploaded_file($upfile) )  {   echo(&quot;你什么都没有上传哦!&quot;);   exit();  }  else  {   if( !ereg(&quo			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mlmm7Yp.html" rel="bookmark">两种php实现图片上传的方法&lowbar;php技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				图片上传在项目中经常用到,几乎没有任何一个项目可以脱离图片或者是文件上传.本篇我在这向大家介绍两种常规的上传方式.(注:在这里我们仅仅是对功能的实现,不去做过多的前端的样式)一.利用form表单上传 此种方式是最原始的上传方式,前端就是简单的form表单,后端我们有PHP处理传输过来的文件. 首先看前端的代码 upload.html &lt;form action=&quot;handle.php&quot; name=&quot;form&quot; method=&quot;post&quot; en			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/boLlBDM.html" rel="bookmark">用PHP实现多服务器共享SESSION数据的方法&lowbar;php技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				PHP 实现多服务器共享 SESSION 数据 /google 的广告条--&gt; 一.问题起源 稍大一些的网站,通常都会有好几个服务器,每个服务器运行着不同功能的模块,使用不同的二级域名,而一个整体性强的网站,用户系统是统一的,即一套用户名.密码在整个网站的各个模块中都是可以登录使用的.各个服务器共享用户数据是比较容易实现的,只需要在后端放个数据库服务器,各个服务器通过统一接口对用户数据进行访问即可.但还存在一个问题,就是用户在这个服务器登录之后,进入另一个服务器的别的模块时,仍然需要重新登录,这			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MxWJ1Rb.html" rel="bookmark">php实现SAE上使用storage上传与下载文件的方法&lowbar;php技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了php实现SAE上使用storage上传与下载文件的方法.分享给大家供大家参考.具体如下: &lt;?php if ($_FILES[&quot;file&quot;][&quot;error&quot;] &gt; 0) { echo &quot;Error: &quot; . $_FILES[&quot;file&quot;][&quot;error&quot;] . &quot;&lt;br /&gt;&quot;; } else { echo &quot;Upload: &quot;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MNje2JM.html" rel="bookmark">js&plus;html5获取用户地理位置信息并在Google地图上显示的方法&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了js+html5获取用户地理位置信息并在Google地图上显示的方法.分享给大家供大家参考.具体实现方法如下: &lt;!DOCTYPE html&gt; &lt;html&gt; &lt;body&gt; &lt;p id=&quot;demo&quot;&gt;Click the button to get your position:&lt;/p&gt; &lt;button onclick=&quot;getLocation()&quot;&gt;Try It&lt;/button&			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMgq93z.html" rel="bookmark" class="title">ODBC文件DSN 的结构</a>
					<div>
						odbc                        ODBC文件DSN 的小秘密1. 用附件带的WORDPAD文本编辑器,  建立一后缀名为 .DSN的文件,  格式如下, 然后按文本格式存起来: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/LzJy27p.html" rel="bookmark" class="title">AS代码2&period;0：新的语言元素</a>
					<div>
						Flash的ActionScript(简称AS)代码控制是Flash实现交互性的重要组成部分,也是区别于其他动画软件的看家本领.今年新发布的Flash MX Professional 2004的动作脚 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Lp5P2RM.html" rel="bookmark" class="title">并不是每一位SEOer都知道的外链建设法则</a>
					<div>
						在网站排名之中,并不是我们以往发的所有外链都对排名有作用,有些外链仅仅是昙花一现,你前脚发,后面站长就给你删除了,我个人觉得这样的链接并没有什么意思.今天自贡SEO主要给大家分享关于外链的三个问题.持 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze4Z48p.html" rel="bookmark" class="title">UI前沿技术&colon; 不局限于网格</a>
					<div>
						画布是 Windows Presentation Foundation (WPF) 和 Silverlight 中提供的若干布局选项之一,它是其中与传统布局传承最为紧密的.在使用子元素填充画布时,通过 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLOXGkM.html" rel="bookmark" class="title">在ASP&period;NET 2&period;0中使用RDLC格式的报表的问题</a>
					<div>
						最近做的项目中需要根据数据绘制折线图,于是就想利用VS2005自带的报表工具做.一开始很顺利,后来发现页面绘制的图表,不能随参数变化而变化,为此折腾了大半个下午,真是阴沟里翻船,最后发现缺少对 Rep ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgKlgAM.html" rel="bookmark" class="title">电脑进程知识与手工杀毒</a>
					<div>
						作为一个电脑使用者,你是否认识电脑的进程呢?知识他们的作用吗?如果不太明白,就阅读一下本文,掌握一些进程的基本知识,因为某些病毒就是在进程里搞鬼.如果你掌握进程的基本知识,就能有效的防范. 如何知道系 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8ZZoNb.html" rel="bookmark" class="title">仿水彩油画照片效果的PS教程</a>
					<div>
						一个特殊的电影放映机用来一次播放一帧画面,只不过这种电影不是映射在荧幕上,而是映射在艺术家的纸上.你只需要一帧一帧的来描绘出各个画面就可以了.利用这种技术得到的手绘的运动图象也会给人一种强烈的栩栩如生 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pP81q1p.html" rel="bookmark" class="title">Windows8笔记本使用过程中键盘按键错乱的解决方法</a>
					<div>
						现在笔记本电脑已经是PC市场的主流,多数用户倾向于使用笔记本电脑.不过有一些用户表示,他们在使用Windows8笔记本电脑时,偶尔会出现键盘按键错乱的情况. 具体情况如上图所示,这种情况可能是键盘按键 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRwn4Kp.html" rel="bookmark" class="title">Win7系统关闭80端口的方法</a>
					<div>
						  1.首先找到开始菜单中的运行选项,然后输入&quot;CMD&quot;打开命令提示符; 2.然后在光标处输入&quot;netstat -ano|findstr 80&quot;,可以查看到80 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGJ9jlp.html" rel="bookmark" class="title">mfc-MFC 录入多组数据问题，求解答</a>
					<div>
						问题描述 MFC 录入多组数据问题,求解答 如图,举个例子,我想输入4组作业信息每组作业信息包括作业名,作业编号,提交时间,运行时间,点一次按钮实现输入一组信息,输入完4组信息点击提交,请问怎么做 解 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
									<a href="https://www.iamivan.net/a/pdEyn2z.html" class="thumbnail">
				<img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxMzExMDcxMTM4MDM3MTg/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2YjNWNVlXNW5YM0JsYm1jPS9mb250LzVhNkw1TDJUL2ZvbnRzaXplLzQwMC9maWxsL0kwSkJRa0ZDTUE9PS9kaXNzb2x2ZS83MC9ncmF2aXR5L1NvdXRoRWFzdA==.jpg">
							</a>
							<div class="info"   >
					<a href="https://www.iamivan.net/a/pdEyn2z.html" rel="bookmark" class="title">我的Android进阶之旅------&amp;amp&semi;gt&semi;Android安全退出应用程序的几种方式</a>
					<div>
						当应用不再使用时,通常需要关闭应用,可以使用以下几种方法关闭android应用: 第一种方法:首先获取当前进程的id,然后杀死该进程.  建议使用这种方式 android.os.Process.kil ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/My3Eedz.html" rel="bookmark" class="title">NYOJ290-动物统计加强版</a>
					<div>
						动物统计加强版 时间限制:3000 ms    内存限制:150000 KB 难度:4 描述 在美丽大兴安岭原始森林中存在数量繁多的物种,在勘察员带来的各种动物资料中有未统计数量的原始动物的名单.科学 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2PBKqp.html" rel="bookmark" class="title">韩国SBS靠出售《Running Man》版权还清债务</a>
					<div>
						去年在韩国市场并没有多大作为的SBS电视台综艺节目&lt;周日真好·Running Man&gt;却在中国收获了意外的惊喜.现在韩版&lt;Running Man&gt;已经成为了韩流综艺的代表作品, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPB4vmb.html" rel="bookmark" class="title">本人小白，测试框架是不是只有自动化测试才有，求大神解答，谢谢谢谢谢谢谢谢</a>
					<div>
						问题描述 本人小白,测试框架是不是只有自动化测试才有,求大神解答,谢谢谢谢谢谢谢谢 测试框架是不是只有自动化测试才有,什么是测试框架,是不是就是一串代码? 解决方案 看你在什么场合看到的这个词.一切可 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgRr65b.html" rel="bookmark" class="title">lamp-fpm-【php-fpm的安装】安装遵循教程，其中有一句&OpenCurlyDoubleQuote;make all install&rdquo;不知道怎么操作</a>
					<div>
						问题描述 [php-fpm的安装]安装遵循教程,其中有一句&quot;make all install&quot;不知道怎么操作 还请告知如何具体操作及应该输入什么样的指令,谢谢 解决方案 make  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnRRdrp.html" rel="bookmark" class="title">白山云科技：首创&OpenCurlyDoubleQuote;乐高式松耦合&rdquo;架构 提供像拼积木一样的云分发服务</a>
					<div>
						国内这两年云计算的发展,让很多人看准了其中各个垂直领域的创业方向.相较行内的老牌厂商,白山云科技(以下简称白山)尚处创业阶段.这家成立于2015年4月的国内首家云链服务提供商,以云分发为切入点,为企业 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3JJgkz.html" rel="bookmark" class="title">Evaluate Math Expression</a>
					<div>
						Evaluate Math Expression eryar@163.com 摘要Abstract:本文简要介绍了数学表达式解析求值的几款开源软件,并结合程序代码说明了OpenCascade中表达式包 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRNVdaM.html" rel="bookmark" class="title">java源码-求解这道题目，求源代码&quest;&quest;&quest;&quest;</a>
					<div>
						问题描述 求解这道题目,求源代码???? 这道题求解,用scanner输入流和一维数组和循环怎么解决呢????????? 解决方案 循环体里面 用数组接收传进来的值(选手姓名 和 分数) 然后按照计算 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeoqZxM.html" rel="bookmark" class="title">纳达尔推特遭入侵 黑客所发内容现已被删除</a>
					<div>
						纳达尔资料图 9月15日讯 体坛明星社交媒体频繁遭黑客入侵,网球圈也不例外.几年前,诺瓦克-德约科维奇的Instagram帐号被黑客入侵,本周三轮到了刚刚夺得美网冠军的拉斐尔-纳达尔. 有黑客设法入侵 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjwWLVM.html" rel="bookmark" class="title">多次获取网卡地址的结果不一样是怎么回事啊？</a>
					<div>
						问题描述 我在托管C++里面找这别人的例子写了个获取网卡地址的函数,运行的时候也能正常的获取网卡地址,只是不知道为什么多次运行的结果不一样?有的机子怎么运行获取都是一样的,有的机子这次和下次运行的就不 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLgr68M.html" rel="bookmark" class="title">SQL数据库大表有9000条记录，为什么读取需要5秒时间，WinForm？</a>
					<div>
						问题描述 publicstaticDataTableDt(stringsql){try{sql=sql.Replace(&quot;rn&quot;,&quot;&quot;);DataTabledt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8NkK4b.html" rel="bookmark" class="title">请各位大神指教 路径错了怎么修改？</a>
					<div>
						问题描述 请各位大神指教 路径错了怎么修改? 解决方案 如果是你自己的程序,你还不知道怎么改? 如果不是你的,那没办法了 解决方案二: 你的网站路径配置错了,是不是你的相对root的路径没有配置正确  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zV700Kb.html" rel="bookmark" class="title">非常不错的关于IE与FireFox的js和css几处不同点&lbrack;转自星火燎原&rsqb;&lowbar;经验交流</a>
					<div>
						在蓝色上看到这篇文章的,感觉作者总结的不错,至少有些偶自己也没有真正的认识过.这些 东西的确是应该好好总结一下的,可惜偶这人比较懒,收藏整理于此,便于自己学习! 1.firefox不能对innerTe ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBk4akM.html" rel="bookmark" class="title">jQuery&plus;css实现的蓝色水平二级导航菜单效果代码&lowbar;jquery</a>
					<div>
						本文实例讲述了jQuery+css实现的蓝色水平二级导航菜单效果.分享给大家供大家参考.具体如下: 这是一款蓝色经典的jQuery+CSS实现水平二级导航菜单,相信你会喜欢的,蓝色,超级经典的一种风格 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boLBqVM.html" rel="bookmark" class="title">tomcat加载&sol;conf&sol;Catalina&sol;localhost下的xml会把xml第一个字母省略掉</a>
					<div>
						问题描述 tomcat加载/conf/Catalina/localhost下的xml会把xml第一个字母省略掉 信息: Container org.apache.catalina.core.Conta ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZ2366z.html" rel="bookmark" class="title">webloigc 会话-weblogic10&period;0&period;3集群会话问题</a>
					<div>
						问题描述 weblogic10.0.3集群会话问题 单机纵向集群,2个服务结点,1个代理结点,测试操作步骤如下: 1.启动控制结点: 2.启动代理结点: 3.启动服务结点1: 4.登录应用: 5.启动 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zena9Ab.html" rel="bookmark" class="title">你不能靠工资赚钱或存钱。在 40 年里，工资与通货膨胀相比，是在下降的</a>
					<div>
						在我 20,22,24,29,33,37,40 岁的时候,我设法把自己绷得很紧,因此我决定把我了解的.称之为的&quot;个人财务&quot;的所有认识写下来.&quot;个人财务&quot;这个词语 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mqgjkkz.html" rel="bookmark" class="title">Eclipse&plus;Java&plus;OpenCV246环境搭建和代码测试</a>
					<div>
						1.首先下载OpenCV2.4.6,下载的时候,选择windows版的.然后安装 2.其实安装的过程就是解压的过程,并没有什么安装向导之类的,安装完成后,我们最关心的是这个目录:opencv\buil ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6YWkLb.html" rel="bookmark" class="title">Office 2010打开文档时报错&amp;quot&semi;不是有效的 Win32 应用程序&amp;quot&semi; 怎么办</a>
					<div>
						装上 Office 2010 之后它的表现一贯还是很给力的.但某次被人给恶作剧改动了一下,现在每每打开文档,就弹出错误提示:不是有效的 Win32 应用程序.该怎么修复呢? 收起这个图片展开这个图片  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgWEABM.html" rel="bookmark" class="title">酷6传媒发布2011年第四季度和全年未审计的财报</a>
					<div>
						和讯科技消息 北京时间3月8日,据国外媒体报道,酷6传媒今天发布了2011年第四季度和全年未审计的财报.财报显示,2011年第四季度,酷6传媒总营收达到442万美元,同比下滑34.7%:净亏损达到39 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.034 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
